;// ԃf[^擾vgRV3Ή
;//   A^Cf[^]  \vV[W
;//                     2020-05
;//						NIFS LABCOM
;//

;//	g`pvV[W
PRO	Wave3Monitor,diagName,channelNumber,cport,udp=udp,nsum=nsums,thinning=thinnings,host=dashost
	usage = 0
	if( n_params(0) ne 3 ) AND ( n_params(0) ne 2) then begin
		usage = 1
	endif
	if( KEYWORD_SET(dashost) ) then begin
		ttype = size(dashost)
		if( 7 ne ttype(1) ) then begin
			usage = 1
		endif
	endif
	if( 1 eq usage ) then begin
		print, 'Usage:'

		print, '  Wave3Monitor,diagName,channelNumber[,portNumber][,/udp][,nsum=N][,thinning=N][,host=HostName]'

		print, ' '
		print, 'Input Parameters:'
		print, '  < diagName      - Diagnostics name'
		print, '  < channelNumber - Channel number'
		print, '  < portNumber    - CONTROL port number'
		print, '  < /udp          - data transfer by UDP'
		print, '  < nsum=N        - plot average of N samples'
		print, '  < thinning=T    - set transfer thinning rate to 1/T'
		print, '  < host=HostName - Host name (''DAS15'',.., etc.)'
		
		retall
	endif
	
	if( n_params(0) eq 2) then begin
		ctrl_port = long(-1)
	endif else begin
		ctrl_port = long(cport)
	endelse
	
	if (KEYWORD_SET(nsums)) then begin
		ns = nsums
	endif else begin
		ns = 1
	endelse
	if (KEYWORD_SET(thinnings)) then begin
		thin = long(thinnings)
	endif else begin
		thin = long(1)
	endelse
	RT3Retrieve,diagName,channelNumber,ctrl_port,udp=udp,nsum=ns,thinning=thin,host=dashost
END

;//	g`pvV[W
PRO	RT3Retrieve,diagName,channelNumber,ctrl_port,udp=udp,nsum=nsums,thinning=thinnings,host=dashost

	thin_type=fix(0);
	if (KEYWORD_SET(udp)) then begin
		packet_size = 0L
	endif else begin
		packet_size = -1L
	endelse
	ch_list = string(channelNumber,FORMAT='(i0)')

	quit='p'
	is_gdl=1;
	if( -1 EQ strpos(strupcase(!DIR),'GDL') ) then is_gdl=0
	print,'Terminate when "q" or "Q" is entered.'

	;//	DLL̂ꏊw
	if( !version.memory_bits EQ 64 ) then object = !Retrieve + '/bin64/RTTransClientDLL.dll' $
	else object = !Retrieve + '/bin/RTTransClientDLL.dll'

	symbol_Start	= 'IdlRTCStart'
	symbol_End		= 'IdlRTCEnd'
	symbol_Open		= 'IdlRTCopen'
	symbol_GetParam = 'IdlRTCgetChannelParam'
	symbol_Close	= 'IdlRTCclose'
	symbol_GetData	= 'IdlRTCgetChannelData'
	symbol_GetChParam = 'IdlRTCgetChannelKeyParam'
	symbol_Transfer	= 'IdlRTCtransfer'
	symbol_ErrMsg	= 'IdlRTCerrorMessage'
	
	rtd = long(0)
	status = long(0)
	samplingInterval = long(0)
	valueLen = 0
	recLen = long(0)
	tmp_interval = 0L
	tmp_valuelen = 0
	tmp_reclen = 0L
	
	;//	T[oւ̐ڑJnv
	result = call_external( object, symbol_Start)
	if (result ne 0) then begin
		msg = call_external( object, symbol_ErrMsg, rtd, /S_Value)
		print, msg
		retall
	endif
	if( NOT KEYWORD_SET(dashost) ) then begin
		dashost=''
	endif
	
	rtd = call_external( object, symbol_Open,$
					diagName, dashost, ch_list, ctrl_port, packet_size, thinnings, thin_type, $
					VALUE=[1,1,1,0,0,0,0])
	if (rtd le 0) then begin
		msg = call_external( object, symbol_ErrMsg, rtd, /S_Value)
		print, msg
		retall
	endif

	result = call_external( object, symbol_GetParam,$
					rtd, channelNumber, samplingInterval, valueLen, recLen)
	if (0 GT result) then GOTO,ABORT_RT
	
	imageType = bytarr(256)
	result = call_external( object, symbol_GetChParam,$
					rtd, channelNumber, 'ImageType', imageType, 256L, VALUE=[0,0,1,0,0])
	if (0 GT result) then GOTO,ABORT_RT
	
	sImageType = string(imageType)
	if( sImageType eq 'IllegalParameterName' ) then begin
		print,'Format is unkown(valueLen:' + string(valueLen,format='(I2)') + ').'
	endif else begin
		print,'Format is '+ sImageType +'(valueLen:' + string(valueLen,format='(I2)') + ').';
	endelse
	;//	\邽߂̔z쐬
	;//	Tvł̓vbg_w
	;//	Ƃ4000^
	pointnum = 4000
	;//	f[^Mpobt@쐬
	;//	IdlLRTGetChannelParam ĂԂƂɁArecLen ɂ̓f[^pPbgP
	;//	Ɋ܂܂TvOf[^̌擾Ă܂
	if (valueLen le 8) then begin
		bytePerSample = 1
		ttype = 1; BYTE
	endif else if (valueLen le 16) then begin
		bytePerSample = 2
		ttype = 2;	INT(SHORT)
	endif else if (valueLen le 32) then begin
		bytePerSample = 4
		if( 'FLT32' eq sImageType ) then begin
			ttype = 4; FLOAT
		endif else begin
			ttype = 3; LONG(32bit-Int)
		endelse
	endif else if (valueLen le 64) then begin
		bytePerSample = 8
		if( 'FLT64' eq sImageType ) then begin
			ttype = 5; DOUBLE
		endif else begin
			ttype = 14; LON64(IDL, NOT pv-wave)
		endelse
	endif
	
	bufsize = recLen/bytePerSample
	if (bufsize gt pointnum) then begin
		pointnum = bufsize * 2
	endif
	buf      = make_array(bufsize, type=ttype)
	plotdata = make_array(pointnum,  type=ttype)

	window, 1
	wshow, 1, 1

	prehead=long(0)
	;//	f[^MۂɁAVbgԍȂǂ󂯎邽߂̗̈m
	shot = long(0);
	subshot = long(0);

	;//	ubNԍ1n܂AT[o玟̃ubN
	;//	Ă邲ƂɃV[PVɑĂ܂
	blk = long(0);
	preblk = long(-1);

	;//	MubN̐擪ƍŏITvOf[^
	;//	Wf[^ŉԖڂɂ邩܂
	head = 0LL;
	tail = 0LL;
    timeout = long(1000); // msec
	;//	ĂubÑTCY
	blen = long(0);
	result = call_external( object, symbol_Transfer, rtd, 1);
	if (0 GT result) then GOTO,ABORT_RT
	
	;//	f[^M̂߂̃[v 
	;//for loopn=1, 10000 do begin
	repeat begin

		;//	f[^M֐Ăяo
		result = call_external( object, symbol_GetData, rtd, channelNumber, timeout, status, shot, subshot, blk, head, tail, buf, blen)
		if( result EQ 2 ) then begin
			print,'RTTRANSD STOPPED'
			GOTO, STOP_PRO
		endif
		if( result EQ 0 ) then begin
			;//	ubÑoCgAobt@vZ
			;//	̃Tvł́A1TvO2oCgƌ߂Ă܂
			buflen = blen / bytePerSample

			;//	status  -1, 3, 5, 8 ԂĂ\܂
			;//	-1 ͈Ӗ̂f[^ŁA̕ϐɂӖȒlĂ܂̂
			;//	Ȃj܂
			;//	vY}f[^WJnO͂قڂׂ -1 ɂȂA
			;//	܂f[^Włf[^҂̂Ƃɂ -1 ԂĂ܂

			;//	3, 5 ̓T[oꂼꃂW[ZbgAbvƏsƂɕԂĂ܂
			;//	VbgԍATuVbgԍɂ͗LȒlĂ܂̂
			;//	KvȏΗpł܂

			;//	8 ̓vY}vɃf[^ĂƂɕԂĂ܂
			;//	̕ϐɂꂼLȒlA
			;// w肵obt@ɂ͎Mf[^܂

			;//	f[^Mۂ̏
			;//	̃Tvł́AG[lA󂯎obt@
			;//	XɃvbgp̔zɓĂAXN[Ȃ
			;//	\悤ɂȂĂ܂
			;//	ۂɂ̓pPbg肱ڂۂȂǂ̂߁AubNԍAhead,tail Ȃ
			;//	pĎ肱ڂf[^͔΂ĕ\ق̂ƂȂ܂
			if status NE 8 then begin
				prehead = 0
				preblk = 0
			endif
			if ( status EQ 8 ) AND ( buflen GT 0 )then begin
				if preblk LT blk then begin
					; scroll
					sx = buflen
					plotdata(0 : pointnum - sx - 1) = plotdata(sx : pointnum - 1)

					; new data
					plotdata(pointnum - buflen : pointnum - 1) = buf(0 : buflen - 1)

					plot, plotdata, nsum = nsums, Title = diagName+' SHOT#'+string(shot,format='(i0)')+' CH#'+string(channelNumber,format='(i0)')+' Event#'+string(blk,format='(i0)')
					wait, 0.01
					if( 0 NE is_gdl ) then wshow
					prehead = head
					preblk = blk
				endif
			endif else begin
				print,shot, subshot,status,blk,blen
				if ( status EQ 3 ) then begin
					status = call_external( object, symbol_GetParam,$
							rtd, channelNumber, tmp_interval, tmp_valuelen, tmp_reclen)
					if (status ge 0 AND recLen NE tmp_reclen) then begin
						recLen=tmp_reclen
						bufsize=recLen/bytePerSample
						buf    = make_array(bufsize, type=ttype)
						if (bufsize GT pointnum) then begin
							pointnum = bufsize * 2
							plotdata = make_array(pointnum,  type=ttype)
						endif
					endif else if (status LT 0) then begin
						msg = call_external( object, symbol_ErrMsg, status, /S_Value)
						print, msg
						GOTO, STOP_PRO
					endif
				endif
			endelse
		endif
		if( 0 EQ is_gdl ) then begin
			wait,0.01				;need in IDL
			quit = GET_KBRD(0)		;abnormal in GDL
		endif
	ENDREP UNTIL STRLOWCASE(quit) EQ 'q' 
;//	endfor

STOP_PRO:
	result = call_external( object, symbol_Transfer, rtd, 0);
	;//	ʐMIۂ̏
	;//	T[oƂ̐ڑN[Y
ABORT_RT:
	IF (0 GT result) then begin
		msg = call_external( object, symbol_ErrMsg, result, /S_Value)
		print, msg
	endif

	result = call_external( object, symbol_Close, rtd)

	;//	DLL ̏Iw
	result = call_external( object, symbol_End)
END

;// JpvV[W
PRO	TV3Monitor,diagName,channelNumber,cport,udp=udp,thinning=thinnings,mode=imageformat,host=dashost,adjust=adj
	usage = 0
	if( n_params(0) ne 3 ) AND ( n_params(0) ne 2) then begin
		usage = 1
	endif
	if( KEYWORD_SET(dashost) ) then begin
		ttype = size(dashost)
		if( 7 ne ttype(1) ) then begin
			usage = 1
		endif
	endif
	if( KEYWORD_SET(imageformat) ) then begin
		ttype = size(imageformat)
		if( 7 ne ttype(1) ) then begin
			usage = 1
		endif
	endif
	if( usage eq 1) then begin
		print, 'Usage:'
		print, '  TV3Monitor,diagName,channelNumber[,portNumber][,thinning=N],[mode=ModeName][host=HostName]'
		print, ' '
		print, 'Input Parameters:'
		print, '  < diagName      - Diagnostics name'
		print, '  < channelNumber - Channel number'
		print, '  < portNumber    - CONTROL port number'
		print, '  < /udp          - data transfer by UDP'
		print, '  < thinning=N    - set transfer thinning rate to 1/N'
		print, '  < mode=ModeName - camera image format (''GRAYn''(default:GRAY8), ''RGB'', ''UYVY'', ''YUY2'')'
		print, '  < host=HostName - Host name (''DAS15'',.., etc.)'
		retall
	endif
	
	if( n_params(0) eq 2) then begin
		ctrl_port = long(-1)
	endif else begin
		ctrl_port = long(cport)
	endelse
	if (KEYWORD_SET(thinnings)) then begin
		thin = long(thinnings)
	endif else begin
		thin = long(1)
	endelse
	
	RT3CamRetrieve,diagName,channelNumber,ctrl_port,udp=udp,thinning=thin,mode=modename,host=dashost,adjust=adj
END
;//	JpvV[W
PRO	RT3CamRetrieve,diagName,channelNumber,ctrl_port,udp=udp,thinning=thinnings,mode=imageformat,host=dashost,adjust=adj
	
	thin_type=fix(0);
	if (KEYWORD_SET(udp)) then begin
		packet_size = 0L
	endif else begin
		packet_size = -1L
	endelse
	ch_list = string(channelNumber,FORMAT='(i0)')

	;//	DLL̂ꏊw
	if( !version.memory_bits EQ 64 ) then object = !Retrieve + '/bin64/RTTransClientDLL.dll' $
	else object = !Retrieve + '/bin/RTTransClientDLL.dll'

	;//	ꂼDLL֐w
	symbol_Start	= 'IdlRTCStart'
	symbol_End		= 'IdlRTCEnd'
	symbol_Open		= 'IdlRTCopen'
	symbol_Close	= 'IdlRTCclose'
	symbol_GetParam = 'IdlRTCgetCamParam'
	symbol_GetData	= 'IdlRTCgetChannelData'
	symbol_GetDataFromYUVCamera	= 'IdlRTCcamYUVdata2RGB'
	symbol_Transfer	= 'IdlRTCtransfer'
	symbol_ErrMsg	= 'IdlRTCerrorMessage'
	symbol_Debug	= 'IdlRTCerrorVerbose'
	symbol_GetChParam = 'IdlRTCgetChannelKeyParam'
	
;	result = call_external( object, symbol_Debug, 1)

	;//	DLL֐ɃANZXAl擾ϐ̗̈m
	rtd = long(0)
	status = long(0)
	pixelDepth = 0
	frameRate = 0
	frameWidth = 0
	frameHeight = 0
	recLen = long(0)
	packetSize = long(0)

	;//	T[oւ̐ڑJnv
	result = call_external( object, symbol_Start)
	if (result ne 0) then begin
		msg = call_external( object, symbol_ErrMsg, rtd, /S_Value)
		print, msg
		retall
	endif
	if( NOT KEYWORD_SET(dashost) ) then begin
		dashost=''
	endif
	
	rtd = call_external( object, symbol_Open,$
				diagName, dashost, ch_list, ctrl_port, packet_size, thinnings, thin_type, VALUE=[1,1,1,0,0,0,0])
	if (rtd le 0) then begin
		msg = call_external( object, symbol_ErrMsg, rtd, /S_Value)
		print, msg
		retall
	endif
	if (NOT KEYWORD_SET(imageformat)) then begin
		imageType = bytarr(256)
		result = call_external( object, symbol_GetChParam,$
						rtd, channelNumber, 'ImageType', imageType, 256L, VALUE=[0,0,1,0,0])
		if (0 GT result) then GOTO, ABORT_PROC
		imageformat = string(imageType)
	endif
	cameramode = 1	;//	default:GRAY8
	arraybits=8
	if(STRUPCASE(imageformat) EQ 'GRAY8') then begin
		print, 'Image Type [GRAY8]'
		arraybits=8
	endif else if(STRUPCASE(imageformat) EQ 'GRAY9') then begin
		print, 'Image Type [GRAY9]'
		arraybits=9
	endif else if(STRUPCASE(imageformat) EQ 'GRAY10') then begin
		print, 'Image Type [GRAY10]'
		arraybits=10
	endif else if(STRUPCASE(imageformat) EQ 'GRAY11') then begin
		print, 'Image Type [GRAY11]'
		arraybits=11
	endif else if(STRUPCASE(imageformat) EQ 'GRAY12') then begin
		print, 'Image Type [GRAY12]'
		arraybits=12
	endif else if(STRUPCASE(imageformat) EQ 'GRAY13') then begin
		print, 'Image Type [GRAY13]'
		arraybits=13
	endif else if(STRUPCASE(imageformat) EQ 'GRAY14') then begin
		print, 'Image Type [GRAY14]'
		arraybits=14
	endif else if(STRUPCASE(imageformat) EQ 'GRAY15') then begin
		print, 'Image Type [GRAY15]'
		arraybits=15
	endif else if(STRUPCASE(imageformat) EQ 'GRAY16') then begin
		print, 'Image Type [GRAY16]'
		arraybits=16
	endif else if(STRUPCASE(imageformat) EQ 'RGB') then begin
		print, 'Image Type [RGB]'
		cameramode = 2
		Rseq = 0
		Gseq = 1
		Bseq = 2
	endif else if(STRUPCASE(imageformat) EQ 'RBG') then begin
		print, 'Image Type [RBG]'
		cameramode = 2
		Rseq = 0
		Gseq = 2
		Bseq = 1
	endif else if(STRUPCASE(imageformat) EQ 'GRB') then begin
		print, 'Image Type [GRB]'
		cameramode = 2
		Rseq = 1
		Gseq = 0
		Bseq = 2
	endif else if(STRUPCASE(imageformat) EQ 'GBR') then begin
		print, 'Image Type [GBR]'
		cameramode = 2
		Rseq = 2
		Gseq = 0
		Bseq = 1
	endif else if(STRUPCASE(imageformat) EQ 'BRG') then begin
		print, 'Image Type [BRG]'
		cameramode = 2
		Rseq = 1
		Gseq = 2
		Bseq = 0
	endif else if(STRUPCASE(imageformat) EQ 'BGR') then begin
		print, 'Image Type [BGR]'
		cameramode = 2
		Rseq = 2
		Gseq = 1
		Bseq = 0
	endif else if(STRUPCASE(imageformat) EQ 'UYVY') then begin
		print, 'Image Type [YUV422:UYVY]'
		cameramode = 3
		yuvfmt=0
	endif else if(STRUPCASE(imageformat) EQ 'YUV422') then begin
		print, 'Image Type [YUV422:UYVY]'
		cameramode = 3
		yuvfmt=0
	endif else if(STRUPCASE(imageformat) EQ 'YUY2') then begin
		print, 'Image Type [YUV422:YUY2]'
		cameramode = 3
		yuvfmt=1
	endif else begin
		print, 'Unknown format [',imageformat,'], ignored. Considering as [GRAY8]'
		GOTO, ABORT_PROC
	endelse


	;//	ʐMp[^擾
	status = call_external( object, symbol_GetParam,$
						rtd, channelNumber, pixelDepth, frameRate, frameWidth, frameHeight, recLen)
	if (status lt 0) then begin
		result = status
		GOTO, ABORT_PROC
	endif
	prePixelDepth = pixelDepth
	preFrameWidth = frameWidth
	preFrameHeight = frameHeight

	;//	f[^Mpobt@쐬
	if(cameramode EQ 1) then begin
		if (arraybits LE 8) then begin
			buf = bytarr(frameWidth, frameHeight)
		endif else begin
			buf = intarr(frameWidth, frameHeight)
		endelse
	endif else if(cameramode EQ 2) then begin
		buf = bytarr(4, frameWidth, frameHeight)
		dsp = bytarr(3, frameWidth, frameHeight)
	endif else if(cameramode EQ 3) then begin
		buf = bytarr(3, frameWidth, frameHeight)
	endif ;//	AYUV422RGBւ̕ϊ̂ݑΉ

	shot = long(0);
	subshot = long(0);
	blk = long(0);
	head = long(0);
	tail = long(0);
	result = call_external( object, symbol_Transfer, rtd, 1);
	if (0 GT result) then GOTO, ABORT_PROC
	
	timeout = 500
	;//	ĂubÑTCY
	blen = long(10);
	if(KEYWORD_SET(adj)) then begin
		wx=frameWidth
		wy=frameHeight
	endif else begin
		wx=640L
		wy=LONG(wx*frameHeight/frameWidth)
	endelse
	window, 1, XSize=wx, YSize=wy
	wshow, 1, 1
	quit='p'
	is_gdl=1;
	if( -1 EQ strpos(strupcase(!DIR),'GDL') ) then is_gdl=0
	print,'Terminate when "q" or "Q" is entered.'
	;//	f[^M̂߂̃[v
;//	for loopn=1, 10000 do begin
	repeat begin

		;//	f[^M֐Ăяo
		if((cameramode EQ 1) OR (cameramode EQ 2)) then begin
			result = call_external( object, symbol_GetData, rtd, channelNumber, timeout, status, shot, subshot, blk, head, tail, buf, blen)
		endif else begin
			result = call_external( object, symbol_GetDataFromYUVCamera, rtd, channelNumber, timeout, status, shot, subshot, blk, head, tail, buf, blen, yuvfmt)
		endelse
		if( result EQ 2 ) then begin
			print,'RTTRANSD STOPPED'
			GOTO, STOP_PRO
		endif
;		print,status,blk,head,blen
		if( result EQ 0 ) then begin

			;//	status  -1, 3, 5, 8 ԂĂ\܂
			;//	-1 ͈Ӗ̂f[^ŁA̕ϐɂӖȒlĂ܂̂
			;//	Ȃj܂
			;//	vY}f[^WJnO͂قڂׂ -1 ɂȂA
			;//	܂f[^Włf[^҂̂Ƃɂ -1 ԂĂ܂

			;//	3, 5 ̓T[oꂼꃂW[ZbgAbvƏsƂɕԂĂ܂
			;//	VbgԍATuVbgԍɂ͗LȒlĂ܂̂
			;//	KvȏΗpł܂
			;//	̃Tvł͉Ă܂

			;//	8 ̓vY}vɃf[^ĂƂɕԂĂ܂
			;//	̕ϐɂꂼLȒlA
			;// w肵obt@ɂ͎Mf[^܂


			;//	f[^Mۂ̏
			;//	̃Tvł́AG[lA󂯎obt@
			;//	XɃvbgp̔zɓĂAXN[Ȃ
			;//	\悤ɂȂĂ܂
			;//	ۂɂ̓pPbg肱ڂۂȂǂ̂߁AubNԍAhead,tail Ȃ
			;//	pĎ肱ڂf[^͔΂ĕ\ق̂ƂȂ܂
			if ( blen GT 0 )then begin
				print,'frame num = ',blk
				if(cameramode EQ 2) then begin
					dsp(0, *, *)=buf(rseq,*,*)
					dsp(1, *, *)=buf(gseq,*,*)
					dsp(2, *, *)=buf(bseq,*,*)
				endif
				erase,1
				if(cameramode EQ 1) then begin
					tvscl, buf, /order
				endif else if(cameramode EQ 2) then begin
					tvscl, dsp, true=1, /order
				endif else begin
					if ( (wx NE frameWidth) OR (wy NE frameHeight) ) then begin
						dsp=CONGRID(buf, wx, wy)
						tvscl, dsp, true=1, /order
					endif else begin
						tvscl, buf, true=1, /order
					endelse
				endelse
				wshow,1,1

				wait, 0.001
			endif else if( (status EQ 3) OR (status EQ 5) ) then begin	;//	fȂǂ擾Ȃď
				result = call_external( object, symbol_GetParam,$
									rtd, channelNumber, pixelDepth, frameRate, frameWidth, frameHeight, recLen)
				if (result lt 0) then begin
					msg = call_external( object, symbol_ErrMsg, result, /S_Value)
					print, msg
					GOTO, STOP_PRO
				endif
				if (prePixelDepth NE pixelDepth) then begin
					print, 'The image depth has changed. Not supported, please restart.'
					GOTO, STOP_PRO
				endif
				if ( (preFrameWidth NE frameWidth) OR (preFrameHeight NE frameHeight) ) then begin
					;//	f[^Mpobt@쐬
					if(cameramode EQ 1) then begin
						if (arraybits LE 8) then begin
							buf = bytarr(frameWidth, frameHeight)
						endif else begin
							buf = intarr(frameWidth, frameHeight)
						endelse
					endif
		
					if(cameramode EQ 2) then begin
						buf = bytarr(4, frameWidth, frameHeight)
						dsp = bytarr(3, frameWidth, frameHeight)
					endif
					
					if(cameramode EQ 3) then begin
						buf = bytarr(3, frameWidth, frameHeight)
					endif ;//	AYUV422RGBւ̕ϊ̂ݑΉ

					if(KEYWORD_SET(adj)) then begin
						wx=frameWidth
						wy=frameHeight
					endif else begin
						wx=640L
						wy=LONG(wx*frameHeight/frameWidth)
					endelse
					window, 1, XSize=wx, YSize=wy
					wshow, 1, 1

					prePixelDepth = pixelDepth
					preFrameWidth = frameWidth
					preFrameHeight = frameHeight
				endif
			endif
		endif
NEXT_LOOP:
		if( 0 EQ is_gdl ) then begin
			wait,0.01				;need in IDL
			quit = GET_KBRD(0)		;abnormal in GDL
		endif
	ENDREP UNTIL STRLOWCASE(quit) EQ 'q' 
STOP_PRO:	
	result = call_external( object, symbol_Transfer, rtd, 0);
ABORT_PROC:
	if (0 GT result) then begin
		msg = call_external( object, symbol_ErrMsg, result, /S_Value)
		print, msg
	endif

	;//	ʐMIۂ̏
	;//	T[oƂ̐ڑN[Y
	result = call_external( object, symbol_Close, rtd)

	;//	DLL ̏Iw
	result = call_external( object, symbol_End)
END
